
/*!
 * @file        main.c
 * @version     1.0
 * @author      linzhangjie
 * @date        2013-10-13
 * @brief       DC_DC_Boost_stellaris
 * PWM			PB6  ֵͨPWMռձ ռձȵڷΧ 5 ~ 95 %
 * PE0			ADC1
 * PE2			ADC2
 */

#ifndef TARGET_IS_BLIZZARD_RA1
#define TARGET_IS_BLIZZARD_RA1
#endif

#ifndef  PART_TM4C123GH6PM
#define  PART_TM4C123GH6PM
#endif

#include <stdbool.h>
#include <stdint.h>
#include "driverlib/rom.h"
#include "driverlib/adc.h"
#include "driverlib/sysctl.h"
#include "driverlib/pwm.h"
#include "driverlib/gpio.h"
#include "driverlib/timer.h"
#include "driverlib/pin_map.h"
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "LCDDriver.h"


int main(void)
{

	// ʹLCD
	LCD_Enable();

	// ʼLCD
	LCD_Init();

	// 
	LCD_ScreenClr();
	int iba=15;
	LCD_Draw_Chinese(1, 0, 0, LCD_DRAW_NORMAL);			// 
	LCD_Draw_Chinese(2, 0, 16, LCD_DRAW_NORMAL);		// ѹ
	LCD_Draw_Char('2', 0, 50, LCD_DRAW_NORMAL);
	LCD_Draw_Char(':', 0, 30, LCD_DRAW_NORMAL);			// :
	LCD_Draw_Char('m', 0, 100, LCD_DRAW_NORMAL);		// m
	LCD_Draw_Char('V', 0, 111, LCD_DRAW_NORMAL);		// V

	int const PART_LM4F120H5QR;

	long  TheSysClock;

	char a,b;

	uint32_t ulADC0_Value[1];
	uint32_t ulADC0_Value1[1];

	// ADC1ʼ
	SysCtlClockSet(SYSCTL_SYSDIV_10|SYSCTL_USE_PLL|SYSCTL_XTAL_16MHZ|SYSCTL_OSC_MAIN);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);

	// ADC1ѡPE0
	GPIOPinTypeADC(GPIO_PORTE_BASE,GPIO_PIN_0);

	// ADC1ѡͨ3
	ADCSequenceConfigure(ADC0_BASE,3,ADC_TRIGGER_PROCESSOR,0);
  	ADCSequenceStepConfigure(ADC0_BASE,3,0,ADC_CTL_CH3 | ADC_CTL_IE | ADC_CTL_END);
  	ADCSequenceEnable(ADC0_BASE,3);
  	ADCIntClear(ADC0_BASE,3);

  	// ADC2ѡPE2
  	GPIOPinTypeADC(GPIO_PORTE_BASE,GPIO_PIN_2);

  	// ADC2ѡͨ1
  	ADCSequenceConfigure(ADC0_BASE,1,ADC_TRIGGER_PROCESSOR,0);
  	ADCSequenceStepConfigure(ADC0_BASE,1,0,ADC_CTL_CH1 | ADC_CTL_IE | ADC_CTL_END);
  	ADCSequenceEnable(ADC0_BASE,1);
  	ADCIntClear(ADC0_BASE,1);

  	// 40 MHz system clock
  	SysCtlClockSet(SYSCTL_SYSDIV_5|SYSCTL_USE_PLL|SYSCTL_XTAL_16MHZ|SYSCTL_OSC_MAIN);

  	unsigned long ulPeriod, dutyCycle;
  	ulPeriod = 3300;
	dutyCycle = 250;

	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
	GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3);
	GPIOPinWrite(GPIO_PORTF_BASE, GPIO_PIN_1|GPIO_PIN_2|GPIO_PIN_3, 0);

	// PB6ΪPWM
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
	GPIOPinConfigure(GPIO_PB6_T0CCP0);
	GPIOPinTypeTimer(GPIO_PORTB_BASE, GPIO_PIN_6);

	// ѡPWMʱ
	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);
	TimerConfigure(TIMER0_BASE, TIMER_CFG_SPLIT_PAIR|TIMER_CFG_A_PWM);
	TimerLoadSet(TIMER0_BASE, TIMER_A, ulPeriod -1);
	TimerMatchSet(TIMER0_BASE, TIMER_A, dutyCycle); // PWM
	TimerEnable(TIMER0_BASE, TIMER_A);

	while(1)
	{
		ADCProcessorTrigger(ADC0_BASE,3);
		while(!ADCIntStatus(ADC0_BASE,3,false));
		ADCSequenceDataGet(ADC0_BASE,3,ulADC0_Value);
		unsigned long sample1 = ulADC0_Value[0] * 3300  / 4096 ;

		// ռձȵ
		if(sample1 <165) sample1 = 165;
		if(sample1 >3135) sample1 = 3135;

		// AD1ΪPWMռձ
		dutyCycle = sample1;
		TimerMatchSet(TIMER0_BASE, TIMER_A, dutyCycle);

		// Һʾռձ
		unsigned char number = '0';
		int i = 0 ;
		unsigned char data[4] = {0};
		data[0] = sample1 / 33000;
		data[1] = (sample1 / 3300) % 10;
		data[2] = 9 - ((sample1 / 330) % 10);
		data[3] = 10 - ((sample1 / 33) % 10);
		for(i = 2; i < 4; ++i)
			LCD_Draw_Char(number + data[i], 1, 50 + 10 * i, LCD_DRAW_NORMAL);
		LCD_Draw_Char('%', 1, 50+10*i, LCD_DRAW_NORMAL);
		SysCtlDelay(SysCtlClockGet()/12);

		// AD2ʾ
		ADCProcessorTrigger(ADC0_BASE,1);
		while(!ADCIntStatus(ADC0_BASE,1,false));
		ADCSequenceDataGet(ADC0_BASE,1,ulADC0_Value1);
		unsigned long sample2 = ulADC0_Value1[0] * 330 / 4096 * 12.1;
		data[0] = sample2 / 1000;
		data[1] = (sample2 / 100) % 10;
		data[2] = (sample2 / 10) % 10;
		data[3] = (sample2 / 1) % 10;
		for(i = 0; i < 4; ++i)
			LCD_Draw_Char(number + data[i], 0, 50 + 10 * i, LCD_DRAW_NORMAL);
		SysCtlDelay(SysCtlClockGet()/12);
	}
}
//---------------------------------------------------------------------------
